﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.8
@EndOfDesignText@
'#IgnoreWarnings:12, 9
Sub Process_Globals
	'this is the name of the page
	Public name As String = "countries"
	Public title As String = "Countries"
	Public icon As String = "fa-solid fa-swatchbook"
	'this variable holds the page controller
	Public page As SDUIPage
	'this variable holds reference to the app
	'usually for constants and other things
	Public app As SDUIApp
	'the variable referencing banano lib
	Private banano As BANano		'ignore
	Private SDUICol1 As SDUICol					'ignore
	Private SDUIRow1 As SDUIRow					'ignore
	'table to list countries Countries
	Private tblcountries As SDUITable			'ignore
	Private spopulation As String
	Private srowcount As String
End Sub
'
'show the page
Sub Show(duiapp As SDUIApp)			'ignore
	'get the reference to the app
	app = duiapp
	pgIndex.UpdateUserName("Anele 'Mashy' Mbanga")
	pgIndex.UpdateUserAvatar("./assets/mashy.jpg")
	'build the page, via code or loadlayouts
	BuildPage
End Sub
'
''the name of the page
Sub getName As String		'ignore
	Return name
End Sub
'
''the icon of the page
Sub getIcon As String		'ignore
	Return icon
End Sub
'
''the title of the page
Sub getTitle As String		'ignore
	Return title
End Sub
'
''back button clicked on the table action bar
Private Sub tblcountries_Back (e As BANanoEvent)
	e.PreventDefault
	'app.ShowPage1(pgHome)
End Sub
'
''start building the page
Private Sub BuildPage
	banano.LoadLayout(app.PageViewer, "countrieslayout")
	'set the title of the table listing
	tblcountries.Title = "Countries"
	'***Add code to export to pdf, xls, csv
	Dim ddown As SDUIDropDown = tblcountries.AddToolbarDropDownIcon("ddown", "fa-solid fa-bars", app.COLOR_ORANGE)
	ddown.AtEnd
	ddown.RoundedBox
	ddown.shadow("")
	'set the colors of the menu
	ddown.ItemHoverColorIntensity("blue", "100")
	ddown.ItemFocusColorIntensity("blue", "100")
	ddown.ItemActiveColorIntensity("blue", "100")
	'add the menu items
	ddown.AddItemIcon("export2pdf", "fa-regular fa-file-pdf", "Export to PDF")
	ddown.AddItemIcon("export2xls", "fa-regular fa-file-excel", "Export to XLS")
	ddown.AddItemIcon("export2csv", "fa-solid fa-file-csv", "Export to CSV")
	'***End code to export to pdf, xls, csv
	'
	tblcountries.AddColumn("name", "Name")
	tblcountries.AddColumnImage("flag", "Flag", "30px", "30px", app.MASK_SQUIRCLE)
	tblcountries.AddColumnThousand("population", "Population")
	tblcountries.AddColumnMoney("area", "Area")
	tblcountries.AddColumn("callingcode", "Calling Code")
	tblcountries.AddColumn("capital", "Capital")
	tblcountries.AddColumn("languages", "Languages")
	'Mount the Countries
	banano.Await(mounted)
End Sub



'Load Countries to table
Sub mounted
	app.PagePause
	'Show loading indicator
	tblcountries.RefreshLoading = True
	Dim j As SDUIFetch
	j.Initialize("https://restcountries.com/v2/all")
	banano.Await(j.GetWait)
	Dim countriesL As List
	countriesL.Initialize
	
	If j.Success Then
		Dim Response As List = j.ToList
		For Each c As Map In Response
			Dim nm As Map = SDUIShared.MapCopyKeys(c, Array("area","capital","flag","name","population","languages","latlng","callingCodes"))
			Dim scallingcode As String = SDUIShared.MapJoinKey(nm, "callingCodes", ",")
			Dim slanguages As String = SDUIShared.MapJoinKey(nm, "languages.name", ",")
			nm.Put("callingcode", scallingcode)
			nm.Put("languages", slanguages)
			countriesL.Add(nm)
		Next
	End If
	banano.Await(tblcountries.SetItemsPaginate(countriesL))
	'sum the totals of each of these columns
	Dim summary As Map = tblcountries.SetFooterTotalSumCountColumns(Array("population"))
	spopulation = summary.Get("population")
	'get the total number of processed rows
	srowcount = summary.Get("rowcount")
	'format the value to be a thousand
	srowcount = SDUIShared.Thousands(srowcount)
	'merge these columns
	tblcountries.SetFooterColumnsMerge(Array("name","flag"))
	'set the first column to show the total
	tblcountries.SetFooterColumn("name", $"Total (${srowcount})"$)
	'Hide loading indicator
	tblcountries.RefreshLoading = False
	app.PageResume
End Sub
'
Private Sub tblcountries_PrevPage (e As BANanoEvent)
	e.PreventDefault
	tblcountries.SetFooterColumn("population", spopulation)
	srowcount = SDUIShared.Thousands(srowcount)
	tblcountries.SetFooterColumn("name", $"Total (${srowcount})"$)
End Sub

Private Sub tblcountries_NextPage (e As BANanoEvent)
	e.PreventDefault
	tblcountries.SetFooterColumn("population", spopulation)
	srowcount = SDUIShared.Thousands(srowcount)
	tblcountries.SetFooterColumn("name", $"Total (${srowcount})"$)
End Sub

'Table refresh button click
Private Sub tblcountries_Refresh (e As BANanoEvent)
	e.PreventDefault
	'Load Countries when refresh is clicked
	banano.Await(mounted)
End Sub
'
'trap the menu actions to export to pdf, xls, csv
Private Sub tblcountries_ddown_Click (item As String)
	Select Case item
		Case "export2pdf"
			banano.Await(tblcountries.ExportToPDF("Countries"))
		Case "export2csv"
			Dim content As String = banano.Await(tblcountries.ExportToCSV(True, ",", True))
			app.Download(content, "Countries.csv")
		Case "export2xls"
			tblcountries.ExportToExcel("Countries", True)
	End Select
End Sub
'
'event when excel download is complete
Private Sub tblcountries_ExcelDownload
	app.ShowSwalSuccess("Excel Report downloaded!")
End Sub
'
'event when pdf download is complete
Private Sub tblcountries_PDFDownload (e As BANanoEvent)
	app.ShowSwalSuccess("PDF Report downloaded!")
End Sub
'
